package grindhouse

import "bytes"
import "fmt"
import "io"
import "os"
import "xml"

type ValgrindInfo struct {
	Clean bool
}

type ValgrindOutput struct {
	XMLName xml.Name `xml:"valgrindoutput"`
	Protocolversion int `xml:"Protocolversion"`
}

func ParseValgrindXml(rio io.Reader) (*ValgrindInfo, os.Error) {
	var valout ValgrindOutput
	xml.Unmarshal(rio, &valout)
	fmt.Printf("valout.Protocolversion = %d\n", valout.Protocolversion)

	buffer := bytes.NewBufferString("")
	xml.Marshal(buffer, valout)
	fmt.Printf("outstring = %s\n", string(buffer.Bytes()))

	vinfo := new(ValgrindInfo)
	vinfo.Clean = true
	return vinfo, nil
}
